
DROP TRIGGER TRU_USER@

------------------------------------------------
-- DDL Statements for TRIGGER TRU_USER
------------------------------------------------

CREATE TRIGGER TRU_USER
  AFTER UPDATE OF 
	  USER_ID,
	  TEAM_ID,
	  USER_NAME,
	  USER_FIRST_NAME,
	  USER_LAST_NAME,
	  USER_PHONE_NUM,
	  USER_STATUS,
	  USER_EMAIL_ADDRESS,
	  LAST_LOGIN_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_USER
  REFERENCING
              NEW AS NEW
              OLD AS OLD
  FOR EACH ROW
BEGIN ATOMIC
DECLARE v_action_type CHAR(6);
DECLARE v_old_user_name CHAR(60);

set v_action_type = 'UPDATE';
set v_old_user_name = 'NULL';
IF ((NEW.LOGICAL_DEL_IND <> OLD.LOGICAL_DEL_IND ) AND (NEW.LOGICAL_DEL_IND = '1'))
THEN
 set v_action_type = 'DELETE';
 set v_old_user_name = OLD.USER_NAME;
END IF;
	INSERT INTO FSX_USER 	(
	  USER_ID,
	  TEAM_ID,
	  OLD_USER_NAME,
	  USER_NAME,
	  USER_FIRST_NAME,
	  USER_LAST_NAME,
	  USER_PHONE_NUM,
	  USER_STATUS,
	  USER_EMAIL_ADDRESS,
	  LAST_LOGIN_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.USER_ID,
	  NEW.TEAM_ID,
	  v_old_user_name,
	  NEW.USER_NAME,
	  NEW.USER_FIRST_NAME,
	  NEW.USER_LAST_NAME,
	  NEW.USER_PHONE_NUM,
	  NEW.USER_STATUS,
	  NEW.USER_EMAIL_ADDRESS,
	  NEW.LAST_LOGIN_TIMESTAMP,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  v_action_type,
	  CURRENT TIMESTAMP
	);
END@
