---------------------------------------------------------------------------------
-- Insert into New Role privileges to support Models Tab
-----------------------------------------------------------------------

merge into FCM_ROLE_PRIVILEGE as rp
 USING (SELECT 
	        r.ROLE_ID as ROLE_ID,
	        p.PRIVILEGE_ID as PRIVILEGE_ID
		FROM    
        	FCM_ROLE r, FCM_PRIVILEGE p
		WHERE   
	        (r.ROLE_NAME = 'Rules Administrator' OR r.ROLE_NAME = 'Rules Editor')  
	        AND p.SYSTEM_PRIVILEGE_NAME = 'VIEWADMIN') AS sh
  ON (rp.ROLE_ID = sh.ROLE_ID 
      and sh.PRIVILEGE_ID = rp.PRIVILEGE_ID)
when not matched then
insert (
	ROLE_ID,
        PRIVILEGE_ID,
        CREATE_USER,
        CREATE_TIMESTAMP,
        LSTUPDT_NBR,
        LOGICAL_DEL_IND) 
VALUES (
	sh.ROLE_ID ,
        sh.PRIVILEGE_ID ,
        CURRENT USER,
        CURRENT TIMESTAMP - CURRENT TIMEZONE,
        0,
        '0'
 )
ELSE IGNORE;



---------------------------------------------------------------------------------
-- Insert into FCM_VERSION
-----------------------------------------------------------------------

INSERT INTO FCM_VERSION (VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.1.0.19', CURRENT DATE, '3.1.0.19 Hotfix DDL', 'DDL')
;
